create or replace procedure ukm_upload is
  -- D.Maslov
  doc DBMS_XMLDOM.DOMDocument;                                                                                        
  xdata  XMLTYPE;
  c CLOB;
  v_cnt number;
begin
  dbms_lob.createtemporary(c, true);
  dbms_lob.append(c, '<updateItems>');
  for xdata in (
               select 
                 c.article,
                 
                 XMLELEMENT("article", c.article)||
                 XMLELEMENT("name", c.name)||
                 XMLELEMENT("measure", '')||
                 XMLELEMENT("measprec", 1)||
                 XMLELEMENT("groupId", c.idclass)||
                 XMLELEMENT("egaisType", 3)
                
                 xml
                
        from SMCARD c, Supermag.SACardClass, Supermag.SACardClass R1
       where Supermag.SACardClass.ID = c.IDClass
         and c.IDClass = R1.ID
         and R1.ID in (select IDCLASS from SACARDCLASSMARK)
      ) loop


      dbms_lob.append(c, '<item>');
      dbms_lob.append(c, xdata.xml);
      select count(1) into v_cnt from SMSTOREUNITS where article = xdata.article;
      if v_cnt > 0 then

          for b in (select barcode from SMSTOREUNITS where article = xdata.article) loop
            dbms_lob.append(c, '<barcode>');
            dbms_lob.append(c, '<id>'||b.barcode||'</id><quantity>1</quantity>');
            dbms_lob.append(c, '</barcode>');
          end loop;

      end if;
      dbms_lob.append(c, '</item>');
       
  end loop;
  dbms_lob.append(c, '</updateItems>');
  
  doc := DBMS_XMLDOM.NewDOMDocument(c);
  DBMS_XMLDOM.WRITETOFILE(doc, 'TEMP/updateItems_[99999]_[I].xml', 'utf-8');

  
  return; 
exception when others then
   SMLOGWRITE(null, null, null, sqlerrm, 'UKM_UPLOAD');  
end ukm_upload;
/
